#include <iostream>
using namespace std;

class Car {

public:
	Car (const string& brand, int production_year,
			int tank_capacity, double fuel_consumption) {
		this->brand = brand;
		this->production_year = production_year;
		this->tank_capacity = tank_capacity;
		this->fuel_consumption = fuel_consumption;
		this->mileage = 0;
		this->current_fuel_level = 0;
	}

	void refueling (int litres) {
		cout << "Getting " << litres << " litres" << endl;
		current_fuel_level += litres;
		if (current_fuel_level > tank_capacity)
			current_fuel_level = tank_capacity;
	}

	void driving (int miles) {
		cout << "Driving " << miles << " miles" << endl;
		if (miles * fuel_consumption / 100 <= current_fuel_level) {
			current_fuel_level -= (int) (miles * fuel_consumption / 100);
		} else {
			miles = (int) (100 * current_fuel_level / fuel_consumption);
			current_fuel_level = 0;
		}
		mileage += miles;
	}

	void print () {
		cout << endl;
		cout << brand << " (" << production_year << ")" << endl;
		cout << "tank capacity " << tank_capacity << endl;
		cout << "fuel consumption " << fuel_consumption << endl;
		cout << "mileage " << mileage << endl;
		cout << "fuel level " << current_fuel_level << endl;
		cout << endl;
	}

private:
	string brand{};
	int production_year;
	int tank_capacity;
	double fuel_consumption;
	int mileage;
	int current_fuel_level;
};

int main () {
	Car car("mercedes", 2000, 50, 5);
//	Car car;
	car.print();
	car.refueling(20);
	car.print();
	car.driving(500);
	car.print();
	car.refueling(40);
	car.print();
	car.driving(500);
	car.print();

	return EXIT_SUCCESS;
}

